;	B_PCM8.FNC	ver.0.00
;	Jan29'97 - Mar2

	include	iocscall.mac
	include	fncpara.inc
	include	basret.mac

trap1vec	equ	$0080+4*1
trap2vec	equ	$0080+4*2

	.text
	dcb.l	6+2,_rts
	dc.l	token,para,exe
	dcb.l	5,0

para:
	dc.l	pcm8_chk
	dc.l	pcm8_stop
	dc.l	pcm8_pause
	dc.l	pcm8_restart
	dc.l	pcm8_mask
	dc.l	pcm8_polymd
exe:
	dc.l	_pcm8_chk
	dc.l	_pcm8_stop
	dc.l	_pcm8_pause
	dc.l	_pcm8_restart
	dc.l	_pcm8_mask
	dc.l	_pcm8_polymd


_rts:	rts


pcm8_mask:
pcm8_polymd:
	dc.w	int_val
pcm8_chk:
	dc.w	int_ret


_pcm8_chk:
	bsr	__pcm8_chk
	ric	d0


_pcm8_mask:
	bsr	__pcm8_chk
	subq.l	#1,d0
	bne	nodrv
	move.w	#$01fb,d0
	move.l	par1i(sp),d1
	trap	#2
	ric	d0


_pcm8_polymd:
	bsr	__pcm8_chk
	subq.l	#1,d0
	bne	nodrv
	move.l	par1i(sp),d1
	addq.l	#1,d1
	moveq	#4,d0
	cmp.l	d0,d1
	bcc	parerr
	subq.w	#1,d1
	move.w	#$01fc,d0
	trap	#2
	ric	d0


pcm8_stop:
pcm8_pause:
pcm8_restart:
	dc.w	void_ret


_pcm8_stop:
	bsr	__pcm8_chk
	subq.l	#1,d0
	bne	nodrv
	move.w	#$0100,d0
	trap	#2
	rvc


_pcm8_pause:
	bsr	__pcm8_chk
	subq.l	#1,d0
	bne	nodrv
	move.w	#$0101,d0
	trap	#2
	rvc


_pcm8_restart:
	bsr	__pcm8_chk
	subq.l	#1,d0
	bne	nodrv
	move.w	#$0102,d0
	trap	#2
	rvc


__pcm8_chk:
regs	reg	d1/a0/a1
; in	nothing
; out	d0.l	0:not 1:kept
; break	ccr
	movem.l	regs,-(sp)
	suba.l	a1,a1
	IOCS	_B_SUPER
	tst.l	d0
	bmi	@f
	movea.l	d0,a1
@@:	moveq	#0,d1
	movea.l	trap2vec.w,a0
	cmpi.l	#'PCM8',-8(a0)
	bne	@f
	moveq	#1,d1
@@:	IOCS	_B_SUPER
	move.l	d1,d0
	movem.l	(sp)+,regs
	rts


nodrv:
	rqf	-1,1,nodrv_mes
parerr:
	rqf	-1,1,parerr_mes


	.data

token:
	dc.b	'pcm8_chk',0
	dc.b	'pcm8_stop',0
	dc.b	'pcm8_pause',0
	dc.b	'pcm8_restart',0
	dc.b	'pcm8_mask',0
	dc.b	'pcm8_polymd',0
	dc.b	0

nodrv_mes:	dc.b	'PCM8풓Ă܂B',0
parerr_mes:	dc.b	'łB',0

	.end
